package threads;

public class PerfectSharedData extends NaiveSharedData {

    private boolean full = false;
    private Object fullLock = new Object();
    private Object readedLock = new Object();

    public PerfectSharedData(int size) {
        super(size);
    }

    @Override
    public void putItem(int index, int item) {
        while (full) {
            synchronized (readedLock) {
                try {
                    System.out.println("Some Consumer is reading data so producer goes to sleep...");
                    readedLock.wait();
                    System.out.println("Producer has been notified");
                } catch (InterruptedException ex) {
                }
            }
        }

        data[index] = item;
        try {
            Thread.sleep(rnd.nextInt(10));
        } catch (InterruptedException ex) {
        }

        if (index == data.length - 1) {
            full = true;
            synchronized (fullLock) {
                fullLock.notify();
            }
        }
    }

    @Override
    public int getItem(int index) {
        while (!full) {
            synchronized (fullLock) {
                try {
                    System.out.println("Consumer (" + Thread.currentThread().getId() + ") waits for data and goes to sleep...");
                    fullLock.wait();
                    System.out.println("Consumer (" + Thread.currentThread().getId() + ") has been notified");
                } catch (InterruptedException ex) {
                }
            }
        }

        int item = data[index];
        try {
            Thread.sleep(rnd.nextInt(50));
        } catch (InterruptedException ex) {
        }

        if (index == data.length - 1) {
            full = false;
            synchronized (readedLock) {
                readedLock.notify();
            }
        }

        return item;
    }
}
